package com.acme;

import com.sun.grizzly.tcp.Request;
import com.sun.grizzly.tcp.Response;
import com.sun.grizzly.util.buf.ByteChunk;
import java.io.OutputStream;

public class MyExecutor implements Runnable
{
    private static final int BUFFER_SIZE = 64 * 1024;

    private Request         req;
    private Response        res;
    private ByteChunk       bc;
    private OutputStream    os;


    public MyExecutor( Request req, Response res )
    {
        this.req = req;
        this.res = res;
        this.bc = new ByteChunk( BUFFER_SIZE );
        this.os = new NullOutputStream();
//        try
//        {
//            this.os = new FileOutputStream( "./tempo/File"+UUID.randomUUID()+".data" );
//        }
//        catch( Exception ex )
//        {
//            ex.printStackTrace();
//        }
    }

    @Override
    public void run()
    {
        int read;

        try
        {
            // Write somewhere the content of the request
            while( (read=req.doRead(bc))!=-1 )
            {
                os.write( bc.getBuffer(), bc.getStart(), read );
            }

            // Simulate some more time consuming operation
            Thread.sleep( 1500 );

            // Respond
            res.setStatus( 200 );
            res.setMessage( "Ok, understand" );
        }
        catch( Exception ex )
        {
            ex.printStackTrace( System.err );
            res.setStatus( 500 );
            res.setMessage( "Error while reading request content" );
        }
        finally
        {
            cleanAndResume();
        }
    }

    private void cleanAndResume()
    {
        try
        {
            os.close();
        }
        catch( Exception ex )
        {
            ex.printStackTrace( System.err );
        }

        try
        {
            res.resume();
        }
        catch( Exception ex )
        {
            ex.printStackTrace( System.err );
        }
    }
}
